#Rem
#Rem $Header:   S:/Expertise/pvcs/commonBuild/600corg.msv   1.8   Jul 30 1999 12:24:00   bhsadhwa  $
#Rem
#Rem Desc: 
#Rem

#ECHO %!b_msgs[B_ECHO_UPDATE_ORG_ID_COMMON]

#REM
#REM Map SYNONYMS to DBCOMMON global variables
#REM
#DEFINE TAB_QUAL {{DBCOMMON:GlobalTabQual}}
#DEFINE COMMAND_TERMINATOR GO
#DEFINE COMMAND_TERMINATION_MODE START_OF_LINE
#DEFINE SITE_NUMBER {{peocfunc:site_no}}

#REM -3701 cannot drop, doesn't exist
#REM -3731 not a valid object
#REM -100 no data

#SUPPRESS -3701
#SUPPRESS -3731
#SUPPRESS -100
#SUPPRESS -4902
#SUPPRESS -208
 
#REM
#REM  Replace script following this remark
#REM

#REM Drop constraints to organization table

#REM I_30 Enforced by tI_ORG_MEMBERSHIP, tU_ORG_MEMBERSHIP
#REM ALTER TABLE <<TAB_QUAL>>.ORG_MEMBERSHIP DROP CONSTRAINT I_30;  

#REM I_29 Enforced by tI_ORG_MEMBERSHIP, tU_ORG_MEMBERSHIP, tU_PEOPLE
#REM ALTER TABLE <<TAB_QUAL>>.ORG_MEMBERSHIP DROP CONSTRAINT I_29;  

DROP TRIGGER <<TAB_QUAL>>.tI_ORG_MEMBERSHIP
go
DROP TRIGGER <<TAB_QUAL>>.tU_ORG_MEMBERSHIP
go
DROP TRIGGER <<TAB_QUAL>>.tU_PEOPLE
go

ALTER TABLE <<TAB_QUAL>>.IS_INVENTORY DROP CONSTRAINT I_52
go

#REM OR_AC Enforced by tI_ACTIONS, tU_ACTIONS
#REM ALTER TABLE <<TAB_QUAL>>.ACTIONS DROP CONSTRAINT OR_AC;

DROP TRIGGER <<TAB_QUAL>>.tI_ACTIONS
go
DROP TRIGGER <<TAB_QUAL>>.tU_ACTIONS
go

#REM OR_CA Enforced by tI_APPROVAL, tU_APPROVAL
#REM ALTER TABLE <<TAB_QUAL>>.APPROVAL DROP CONSTRAINT OR_CA;
               
DROP TRIGGER <<TAB_QUAL>>.tI_APPROVAL
go
DROP TRIGGER <<TAB_QUAL>>.tU_APPROVAL
go
               
#REM OR_CG_AR Enforced by tI_CHANGE, tU_CHANGE                
ALTER TABLE <<TAB_QUAL>>.CHANGE DROP CONSTRAINT OR_CG_AR
go

#REM OR_CG_CC Enforced by tI_CHANGE, tU_CHANGE               
#REM #REM ALTER TABLE <<TAB_QUAL>>.CHANGE DROP CONSTRAINT OR_CG_CC;

DROP TRIGGER <<TAB_QUAL>>.tI_CHANGE
go
DROP TRIGGER <<TAB_QUAL>>.tU_CHANGE
go
                
#REM OR_MO_AR Enforced by tI_CHANGE_MODEL, tU_CHANGE_MODEL 
#REM ALTER TABLE <<TAB_QUAL>>.CHANGE_MODEL DROP CONSTRAINT OR_MO_AR;
               
#REM OR_MO_CC Enforced by tI_CHANGE_MODEL, tU_CHANGE_MODEL 
#REM ALTER TABLE <<TAB_QUAL>>.CHANGE_MODEL DROP CONSTRAINT OR_MO_CC;
   
DROP TRIGGER <<TAB_QUAL>>.tI_CHANGE_MODEL
go
DROP TRIGGER <<TAB_QUAL>>.tU_CHANGE_MODEL
go
               
ALTER TABLE <<TAB_QUAL>>.IMPACT_ITEM DROP CONSTRAINT IM_OR
go
     
#REM OR_MA Enforced by tI_MODEL_APPROVAL, tU_MODEL_APPROVAL               
#REM ALTER TABLE <<TAB_QUAL>>.MODEL_APPROVAL DROP CONSTRAINT OR_MA;

DROP TRIGGER <<TAB_QUAL>>.tI_MODEL_APPROVAL
go
DROP TRIGGER <<TAB_QUAL>>.tU_MODEL_APPROVAL
go

#REM (* ****************************************************************************************   
#REM    6.0-TSD-0014 Defect EQ21392
#REM     Migration of IS_INVENTORY/Organization fails
#REM    MSS 18May00
#REM    **************************************************************************************** *)

DROP TRIGGER <<TAB_QUAL>>.tU_ORGANIZATION
go

DROP TRIGGER <<TAB_QUAL>>.tU_IS_INVENTORY
go

#REM Update organization_id with site_no

#REM UPDATE <<TAB_QUAL>>.ORGANIZATION SET ORGANIZATION_ID = CONVERT(CHAR , (10000000 * <<SITE_NUMBER>> ) + CONVERT(INT,ORGANIZATION_ID) ) 
#REM go

#REM (* ****************************************************************************************   
#REM    END 6.0-TSD-0014 Defect EQ21392
#REM    **************************************************************************************** *)


UPDATE <<TAB_QUAL>>.ORG_MEMBERSHIP SET ORG_MEMBER_ID = (10000000 * <<SITE_NUMBER>> ) + ORG_MEMBER_ID 
go

UPDATE <<TAB_QUAL>>.ORG_MEMBERSHIP SET ORGANIZATION_ID = CONVERT(CHAR , (10000000 * <<SITE_NUMBER>> ) + CONVERT(INT,ORGANIZATION_ID) ) 
go

UPDATE <<TAB_QUAL>>.IS_INVENTORY SET ORGANIZATION_ID = CONVERT(CHAR , (10000000 * <<SITE_NUMBER>> ) + CONVERT(INT,ORGANIZATION_ID) ) 
go

UPDATE <<TAB_QUAL>>.ACTIONS SET ORGANIZATION_ID = CONVERT(CHAR , (10000000 * <<SITE_NUMBER>> ) + CONVERT(INT,ORGANIZATION_ID) ) 
go

UPDATE <<TAB_QUAL>>.APPROVAL SET ORGANIZATION_ID = CONVERT(CHAR , (10000000 * <<SITE_NUMBER>> ) + CONVERT(INT,ORGANIZATION_ID) ) 
go

UPDATE <<TAB_QUAL>>.CHANGE SET RESPONSIBLE_AREA = CONVERT(CHAR , (10000000 * <<SITE_NUMBER>> ) + CONVERT(INT,RESPONSIBLE_AREA) ) 
go

UPDATE <<TAB_QUAL>>.CHANGE SET COST_CENTER = CONVERT(CHAR , (10000000 * <<SITE_NUMBER>> ) + CONVERT(INT,COST_CENTER) ) 
go

UPDATE <<TAB_QUAL>>.CHANGE_MODEL SET RESPONSIBLE_AREA = CONVERT(CHAR , (10000000 * <<SITE_NUMBER>> ) + CONVERT(INT,RESPONSIBLE_AREA) ) 
go

UPDATE <<TAB_QUAL>>.CHANGE_MODEL SET COST_CENTER = CONVERT(CHAR , (10000000 * <<SITE_NUMBER>> ) + CONVERT(INT,COST_CENTER) ) 
go

UPDATE <<TAB_QUAL>>.IMPACT_ITEM SET ORGANIZATION_ID = CONVERT(CHAR , (10000000 * <<SITE_NUMBER>> ) + CONVERT(INT,ORGANIZATION_ID) ) 
go

UPDATE <<TAB_QUAL>>.MODEL_APPROVAL SET ORGANIZATION_ID = CONVERT(CHAR , (10000000 * <<SITE_NUMBER>> ) + CONVERT(INT,ORGANIZATION_ID) ) 
go

UPDATE <<TAB_QUAL>>.ORGANIZATION_TREE SET PARENT = CONVERT(CHAR , (10000000 * <<SITE_NUMBER>> ) + CONVERT(INT,PARENT) ) WHERE PARENT <> '0'
go

UPDATE <<TAB_QUAL>>.ORGANIZATION_TREE SET CHILD = CONVERT(CHAR , (10000000 * <<SITE_NUMBER>> ) + CONVERT(INT,CHILD) ) 
go

UPDATE <<TAB_QUAL>>.SCHED_RESOURCE SET RESOURCE_ID = (10000000 * <<SITE_NUMBER>> ) + RESOURCE_ID  
                                   WHERE RESOURCE_TYPE = 'O'
go                                   

UPDATE <<TAB_QUAL>>.MODEL_SCHED_RES SET RESOURCE_ID = (10000000 * <<SITE_NUMBER>> ) + RESOURCE_ID
                                   WHERE RESOURCE_TYPE = 'O'
go                                   

#REM (* ****************************************************************************************   
#REM    6.0-TSD-0014 Defect EQ21392
#REM     Migration of IS_INVENTORY/Organization fails
#REM    MSS 18May00
#REM    **************************************************************************************** *)

#REM Update organization_id with site_no

UPDATE <<TAB_QUAL>>.ORGANIZATION SET ORGANIZATION_ID = CONVERT(CHAR , (10000000 * <<SITE_NUMBER>> ) + CONVERT(INT,ORGANIZATION_ID) ) 
go

#REM (* ****************************************************************************************   
#REM    END 6.0-TSD-0014 Defect EQ21392
#REM    **************************************************************************************** *)

#REM Re-establish constraints

#REM Enforced by tI_ORG_MEMBERSHIP, tU_ORG_MEMBERSHIP. Created in 600efm.mss or 600efmr.mss
#REM ALTER TABLE <<TAB_QUAL>>.ORG_MEMBERSHIP
#REM ADD  (  CONSTRAINT I_30 FOREIGN KEY  (ORGANIZATION_ID)
#REM                REFERENCES <<TAB_QUAL>>.ORGANIZATION
#REM                ON DELETE CASCADE ) ;

#REM Enforced by tI_ORG_MEMBERSHIP, tU_ORG_MEMBERSHIP, tU_PEOPLE. Created in 600efm.mss or 600efmr.mss
#REM ALTER TABLE <<TAB_QUAL>>.ORG_MEMBERSHIP
#REM ADD  (  CONSTRAINT I_29 FOREIGN KEY  (PEOPLE_ID)
#REM                REFERENCES <<TAB_QUAL>>.PEOPLE
#REM                ON DELETE CASCADE ) ;
               
 ALTER TABLE <<TAB_QUAL>>.IS_INVENTORY
 ADD  CONSTRAINT I_52 FOREIGN KEY  (ORGANIZATION_ID)
                REFERENCES <<TAB_QUAL>>.ORGANIZATION
go                

#REM Enforced by tI_ACTIONS, tU_ACTIONS                
#REM ALTER TABLE <<TAB_QUAL>>.ACTIONS
#REM ADD  (  CONSTRAINT OR_AC FOREIGN KEY  (ORGANIZATION_ID)
#REM                REFERENCES <<TAB_QUAL>>.ORGANIZATION ) ;

#REM ******************************************************
#REM       
#REM    tI_ACTIONS
#REM    
#REM ******************************************************

create trigger tI_ACTIONS on <<TAB_QUAL>>.ACTIONS for INSERT as
/* ERwin Builtin Tue Jun 17 09:00:38 1997 */
/* INSERT trigger on <<TAB_QUAL>>.ACTIONS */
begin
  declare  @numrows int,
           @nullcnt int,
           @validcnt int,
           @errno   int,
           @errmsg  varchar(255)

  select @numrows = @@rowcount
  /* ERwin Builtin Tue Jun 17 09:00:37 1997 */
  /* ORGANIZATION OR_AC ACTIONS ON CHILD INSERT RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(ORGANIZATION_ID)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.ORGANIZATION
        where
          /* %JoinFKPK(inserted,ORGANIZATION) */
          inserted.ORGANIZATION_ID = <<TAB_QUAL>>.ORGANIZATION.ORGANIZATION_ID
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.ORGANIZATION_ID is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30002,
             @errmsg = '%!c_data[C_TRIG_TI_ACTIONS_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* CHANGE_CONTROL_BOA CC_AC ACTIONS ON CHILD INSERT RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(CCB_NAME)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.CHANGE_CONTROL_BOA
        where
          /* %JoinFKPK(inserted,CHANGE_CONTROL_BOA) */
          inserted.CCB_NAME = <<TAB_QUAL>>.CHANGE_CONTROL_BOA.CCB_NAME
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.CCB_NAME is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30002,
             @errmsg = '%!c_data[C_TRIG_TI_ACTIONS_2_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* PEOPLE PO_AC ACTIONS ON CHILD INSERT RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(PEOPLE_ID)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.PEOPLE
        where
          /* %JoinFKPK(inserted,PEOPLE) */
          inserted.PEOPLE_ID = <<TAB_QUAL>>.PEOPLE.PEOPLE_ID
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.PEOPLE_ID is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30002,
             @errmsg = '%!c_data[C_TRIG_TI_ACTIONS_3_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* RULES RU_AC ACTIONS ON CHILD INSERT RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(RULE_ID)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.RULES
        where
          /* %JoinFKPK(inserted,RULES) */
          inserted.RULE_ID = <<TAB_QUAL>>.RULES.RULE_ID
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30002,
             @errmsg = '%!c_data[C_TRIG_TI_ACTIONS_4_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* COMMANDS CO_AC ACTIONS ON CHILD INSERT RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(COMMAND)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.COMMANDS
        where
          /* %JoinFKPK(inserted,COMMANDS) */
          inserted.COMMAND = <<TAB_QUAL>>.COMMANDS.COMMAND
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.COMMAND is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30002,
             @errmsg = '%!c_data[C_TRIG_TI_ACTIONS_5_DB]'
      goto error
    end
  end


  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  return
error:
    raiserror @errno @errmsg
    rollback transaction
end
go

#REM ******************************************************
#REM       
#REM    tU_ACTIONS
#REM    
#REM ******************************************************

create trigger tU_ACTIONS on <<TAB_QUAL>>.ACTIONS for UPDATE as
/* ERwin Builtin Tue Jun 17 09:00:38 1997 */
/* UPDATE trigger on <<TAB_QUAL>>.ACTIONS */
begin
  declare  @numrows int,
           @nullcnt int,
           @validcnt int,
           @insACTION_ID int,
           @errno   int,
           @errmsg  varchar(255)

  select @numrows = @@rowcount
  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* ORGANIZATION OR_AC ACTIONS ON CHILD UPDATE RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(ORGANIZATION_ID)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.ORGANIZATION
        where
          /* %JoinFKPK(inserted,ORGANIZATION) */
          inserted.ORGANIZATION_ID = <<TAB_QUAL>>.ORGANIZATION.ORGANIZATION_ID
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.ORGANIZATION_ID is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30007,
             @errmsg = '%!c_data[C_TRIG_TU_ACTIONS_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* CHANGE_CONTROL_BOA CC_AC ACTIONS ON CHILD UPDATE RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(CCB_NAME)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.CHANGE_CONTROL_BOA
        where
          /* %JoinFKPK(inserted,CHANGE_CONTROL_BOA) */
          inserted.CCB_NAME = <<TAB_QUAL>>.CHANGE_CONTROL_BOA.CCB_NAME
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.CCB_NAME is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30007,
             @errmsg = '%!c_data[C_TRIG_TU_ACTIONS_2_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* PEOPLE PO_AC ACTIONS ON CHILD UPDATE RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(PEOPLE_ID)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.PEOPLE
        where
          /* %JoinFKPK(inserted,PEOPLE) */
          inserted.PEOPLE_ID = <<TAB_QUAL>>.PEOPLE.PEOPLE_ID
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.PEOPLE_ID is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30007,
             @errmsg = '%!c_data[C_TRIG_TU_ACTIONS_3_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* RULES RU_AC ACTIONS ON CHILD UPDATE RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(RULE_ID)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.RULES
        where
          /* %JoinFKPK(inserted,RULES) */
          inserted.RULE_ID = <<TAB_QUAL>>.RULES.RULE_ID
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30007,
             @errmsg = '%!c_data[C_TRIG_TU_ACTIONS_4_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* COMMANDS CO_AC ACTIONS ON CHILD UPDATE RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(COMMAND)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.COMMANDS
        where
          /* %JoinFKPK(inserted,COMMANDS) */
          inserted.COMMAND = <<TAB_QUAL>>.COMMANDS.COMMAND
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.COMMAND is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30007,
             @errmsg = '%!c_data[C_TRIG_TU_ACTIONS_5_DB]'
      goto error
    end
  end


  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  return
error:
    raiserror @errno @errmsg
    rollback transaction
end
go
               
#REM Enforced by tI_APPROVAL, tU_APPROVAL               
#REM ALTER TABLE <<TAB_QUAL>>.APPROVAL
#REM ADD  (  CONSTRAINT OR_CA FOREIGN KEY  (ORGANIZATION_ID)
#REM                REFERENCES <<TAB_QUAL>>.ORGANIZATION ) ;

#REM ******************************************************
#REM       
#REM    tI_APPROVAL
#REM    
#REM ******************************************************
               
create trigger tI_APPROVAL on <<TAB_QUAL>>.APPROVAL for INSERT as
/* ERwin Builtin Tue Jun 17 09:00:38 1997 */
/* INSERT trigger on <<TAB_QUAL>>.APPROVAL */
begin
  declare  @numrows int,
           @nullcnt int,
           @validcnt int,
           @errno   int,
           @errmsg  varchar(255)

  select @numrows = @@rowcount
  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* PEOPLE PO_CA APPROVAL ON CHILD INSERT RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(PEOPLE_ID)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.PEOPLE
        where
          /* %JoinFKPK(inserted,PEOPLE) */
          inserted.PEOPLE_ID = <<TAB_QUAL>>.PEOPLE.PEOPLE_ID
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.PEOPLE_ID is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30002,
             @errmsg = '%!c_data[C_TRIG_TI_APPROVAL_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* CHANGE_CONTROL_BOA CC_CA APPROVAL ON CHILD INSERT RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(CCB_NAME)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.CHANGE_CONTROL_BOA
        where
          /* %JoinFKPK(inserted,CHANGE_CONTROL_BOA) */
          inserted.CCB_NAME = <<TAB_QUAL>>.CHANGE_CONTROL_BOA.CCB_NAME
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.CCB_NAME is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30002,
             @errmsg = '%!c_data[C_TRIG_TI_APPROVAL_2_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* ORGANIZATION OR_CA APPROVAL ON CHILD INSERT RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(ORGANIZATION_ID)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.ORGANIZATION
        where
          /* %JoinFKPK(inserted,ORGANIZATION) */
          inserted.ORGANIZATION_ID = <<TAB_QUAL>>.ORGANIZATION.ORGANIZATION_ID
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.ORGANIZATION_ID is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30002,
             @errmsg = '%!c_data[C_TRIG_TI_APPROVAL_3_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* CHANGE CG_CA APPROVAL ON CHILD INSERT RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(CHANGE_ID)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.CHANGE
        where
          /* %JoinFKPK(inserted,CHANGE) */
          inserted.CHANGE_ID = <<TAB_QUAL>>.CHANGE.CHANGE_ID
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30002,
             @errmsg = '%!c_data[C_TRIG_TI_APPROVAL_4_DB]'
      goto error
    end
  end


  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  return
error:
    raiserror @errno @errmsg
    rollback transaction
end
go

#REM ******************************************************
#REM       
#REM    tU_APPROVAL
#REM    
#REM ******************************************************

create trigger tU_APPROVAL on <<TAB_QUAL>>.APPROVAL for UPDATE as
/* ERwin Builtin Tue Jun 17 09:00:38 1997 */
/* UPDATE trigger on <<TAB_QUAL>>.APPROVAL */
begin
  declare  @numrows int,
           @nullcnt int,
           @validcnt int,
           @insAPPROVER_ID int,
           @errno   int,
           @errmsg  varchar(255)

  select @numrows = @@rowcount
  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* PEOPLE PO_CA APPROVAL ON CHILD UPDATE RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(PEOPLE_ID)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.PEOPLE
        where
          /* %JoinFKPK(inserted,PEOPLE) */
          inserted.PEOPLE_ID = <<TAB_QUAL>>.PEOPLE.PEOPLE_ID
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.PEOPLE_ID is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30007,
             @errmsg = '%!c_data[C_TRIG_TU_APPROVAL_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* CHANGE_CONTROL_BOA CC_CA APPROVAL ON CHILD UPDATE RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(CCB_NAME)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.CHANGE_CONTROL_BOA
        where
          /* %JoinFKPK(inserted,CHANGE_CONTROL_BOA) */
          inserted.CCB_NAME = <<TAB_QUAL>>.CHANGE_CONTROL_BOA.CCB_NAME
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.CCB_NAME is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30007,
             @errmsg = '%!c_data[C_TRIG_TU_APPROVAL_2_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* ORGANIZATION OR_CA APPROVAL ON CHILD UPDATE RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(ORGANIZATION_ID)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.ORGANIZATION
        where
          /* %JoinFKPK(inserted,ORGANIZATION) */
          inserted.ORGANIZATION_ID = <<TAB_QUAL>>.ORGANIZATION.ORGANIZATION_ID
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.ORGANIZATION_ID is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30007,
             @errmsg = '%!c_data[C_TRIG_TU_APPROVAL_3_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* CHANGE CG_CA APPROVAL ON CHILD UPDATE RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(CHANGE_ID)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.CHANGE
        where
          /* %JoinFKPK(inserted,CHANGE) */
          inserted.CHANGE_ID = <<TAB_QUAL>>.CHANGE.CHANGE_ID
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30007,
             @errmsg = '%!c_data[C_TRIG_TU_APPROVAL_4_DB]'
      goto error
    end
  end


  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  return
error:
    raiserror @errno @errmsg
    rollback transaction
end
go
     
#REM Enforced by tI_CHANGE, tU_CHANGE                               
#REM ALTER TABLE <<TAB_QUAL>>.CHANGE
#REM ADD  (  CONSTRAINT OR_CG_AR FOREIGN KEY  (RESPONSIBLE_AREA)
#REM                REFERENCES <<TAB_QUAL>>.ORGANIZATION ) ;
               
#REM Enforced by tI_CHANGE, tU_CHANGE                              
#REM ALTER TABLE <<TAB_QUAL>>.CHANGE
#REM ADD  (  CONSTRAINT OR_CG_CC FOREIGN KEY  (COST_CENTER)
#REM                REFERENCES <<TAB_QUAL>>.ORGANIZATION ) ;
           
#REM ******************************************************
#REM       
#REM    tI_CHANGE
#REM    
#REM ******************************************************
           
create trigger tI_CHANGE on <<TAB_QUAL>>.CHANGE for INSERT as
/* ERwin Builtin Tue Jun 17 09:00:38 1997 */
/* INSERT trigger on <<TAB_QUAL>>.CHANGE */
begin
  declare  @numrows int,
           @nullcnt int,
           @validcnt int,
           @errno   int,
           @errmsg  varchar(255)

  select @numrows = @@rowcount
  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* LOCATION LO_CG CHANGE ON CHILD INSERT RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(LOCATION_ID)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.LOCATION
        where
          /* %JoinFKPK(inserted,LOCATION) */
          inserted.LOCATION_ID = <<TAB_QUAL>>.LOCATION.LOCATION_ID
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.LOCATION_ID is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30002,
             @errmsg = '%!c_data[C_TRIG_TI_CHANGE_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* PEOPLE PO_CG_AS CHANGE ON CHILD INSERT RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(ASSIGNED_TO)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.PEOPLE
        where
          /* %JoinFKPK(inserted,PEOPLE) */
          inserted.ASSIGNED_TO = <<TAB_QUAL>>.PEOPLE.PEOPLE_ID
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.ASSIGNED_TO is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30002,
             @errmsg = '%!c_data[C_TRIG_TI_CHANGE_2_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* PEOPLE PO_CG_RQ CHANGE ON CHILD INSERT RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(REQUESTER_ID)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.PEOPLE
        where
          /* %JoinFKPK(inserted,PEOPLE) */
          inserted.REQUESTER_ID = <<TAB_QUAL>>.PEOPLE.PEOPLE_ID
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.REQUESTER_ID is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30002,
             @errmsg = '%!c_data[C_TRIG_TI_CHANGE_3_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* ORGANIZATION OR_CG_AR CHANGE ON CHILD INSERT RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(RESPONSIBLE_AREA)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.ORGANIZATION
        where
          /* %JoinFKPK(inserted,ORGANIZATION) */
          inserted.RESPONSIBLE_AREA = <<TAB_QUAL>>.ORGANIZATION.ORGANIZATION_ID
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.RESPONSIBLE_AREA is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30002,
             @errmsg = '%!c_data[C_TRIG_TI_CHANGE_4_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* ORGANIZATION OR_CG_CC CHANGE ON CHILD INSERT RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(COST_CENTER)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.ORGANIZATION
        where
          /* %JoinFKPK(inserted,ORGANIZATION) */
          inserted.COST_CENTER = <<TAB_QUAL>>.ORGANIZATION.ORGANIZATION_ID
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.COST_CENTER is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30002,
             @errmsg = '%!c_data[C_TRIG_TI_CHANGE_5_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* CATEGORY CY_CG CHANGE ON CHILD INSERT RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(CATEGORY)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.CATEGORY
        where
          /* %JoinFKPK(inserted,CATEGORY) */
          inserted.CATEGORY = <<TAB_QUAL>>.CATEGORY.CATEGORY
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30002,
             @errmsg = '%!c_data[C_TRIG_TI_CHANGE_6_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* RISK_CODES RC_CG CHANGE ON CHILD INSERT RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(RISK_CODE)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.RISK_CODES
        where
          /* %JoinFKPK(inserted,RISK_CODES) */
          inserted.RISK_CODE = <<TAB_QUAL>>.RISK_CODES.RISK_CODE
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.RISK_CODE is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30002,
             @errmsg = '%!c_data[C_TRIG_TI_CHANGE_7_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* CHANGE_STATUS ST_CG CHANGE ON CHILD INSERT RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(STATUS_ID)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.CHANGE_STATUS
        where
          /* %JoinFKPK(inserted,CHANGE_STATUS) */
          inserted.STATUS_ID = <<TAB_QUAL>>.CHANGE_STATUS.STATUS_ID
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30002,
             @errmsg = '%!c_data[C_TRIG_TI_CHANGE_8_DB]'
      goto error
    end
  end


  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  return
error:
    raiserror @errno @errmsg
    rollback transaction
end
go


#REM ******************************************************
#REM       
#REM    tU_CHANGE
#REM    
#REM ******************************************************
           
create trigger tU_CHANGE on <<TAB_QUAL>>.CHANGE for UPDATE as
/* ERwin Builtin Tue Jun 17 09:00:38 1997 */
/* UPDATE trigger on <<TAB_QUAL>>.CHANGE */
begin
  declare  @numrows int,
           @nullcnt int,
           @validcnt int,
           @insCHANGE_ID int,
           @errno   int,
           @errmsg  varchar(255)

  select @numrows = @@rowcount
  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* CHANGE CG_CT_CH CHANGE_TREE ON PARENT UPDATE RESTRICT */
  if
    /* %ParentPK(" or",update) */
    update(CHANGE_ID)
  begin
    if exists (
      select * from deleted,<<TAB_QUAL>>.CHANGE_TREE
      where
        /*  %JoinFKPK(CHANGE_TREE,deleted," = "," and") */
        <<TAB_QUAL>>.CHANGE_TREE.PARENT_CHANGE_ID = deleted.CHANGE_ID
    )
    begin
      select @errno  = 30005,
             @errmsg = '%!c_data[C_TRIG_TU_CHANGE_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* CHANGE CG_CT_PA CHANGE_TREE ON PARENT UPDATE RESTRICT */
  if
    /* %ParentPK(" or",update) */
    update(CHANGE_ID)
  begin
    if exists (
      select * from deleted,<<TAB_QUAL>>.CHANGE_TREE
      where
        /*  %JoinFKPK(CHANGE_TREE,deleted," = "," and") */
        <<TAB_QUAL>>.CHANGE_TREE.CHILD_CHANGE_ID = deleted.CHANGE_ID
    )
    begin
      select @errno  = 30005,
             @errmsg = '%!c_data[C_TRIG_TU_CHANGE_2_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* CHANGE CH_CA CHANGE_ATTACHMENT ON PARENT UPDATE RESTRICT */
  if
    /* %ParentPK(" or",update) */
    update(CHANGE_ID)
  begin
    if exists (
      select * from deleted,<<TAB_QUAL>>.CHANGE_ATTACHMENT
      where
        /*  %JoinFKPK(CHANGE_ATTACHMENT,deleted," = "," and") */
        <<TAB_QUAL>>.CHANGE_ATTACHMENT.CHANGE_ID = deleted.CHANGE_ID
    )
    begin
      select @errno  = 30005,
             @errmsg = '%!c_data[C_TRIG_TU_CHANGE_3_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* CHANGE CG_CA APPROVAL ON PARENT UPDATE RESTRICT */
  if
    /* %ParentPK(" or",update) */
    update(CHANGE_ID)
  begin
    if exists (
      select * from deleted,<<TAB_QUAL>>.APPROVAL
      where
        /*  %JoinFKPK(APPROVAL,deleted," = "," and") */
        <<TAB_QUAL>>.APPROVAL.CHANGE_ID = deleted.CHANGE_ID
    )
    begin
      select @errno  = 30005,
             @errmsg = '%!c_data[C_TRIG_TU_CHANGE_4_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* CHANGE CG_II IMPACT_ITEM ON PARENT UPDATE RESTRICT */
  if
    /* %ParentPK(" or",update) */
    update(CHANGE_ID)
  begin
    if exists (
      select * from deleted,<<TAB_QUAL>>.IMPACT_ITEM
      where
        /*  %JoinFKPK(IMPACT_ITEM,deleted," = "," and") */
        <<TAB_QUAL>>.IMPACT_ITEM.IMP_CHANGE_ID = deleted.CHANGE_ID
    )
    begin
      select @errno  = 30005,
             @errmsg = '%!c_data[C_TRIG_TU_CHANGE_5_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* CHANGE CG_CM CHANGE_MATRIX ON PARENT UPDATE RESTRICT */
  if
    /* %ParentPK(" or",update) */
    update(CHANGE_ID)
  begin
    if exists (
      select * from deleted,<<TAB_QUAL>>.CHANGE_MATRIX
      where
        /*  %JoinFKPK(CHANGE_MATRIX,deleted," = "," and") */
        <<TAB_QUAL>>.CHANGE_MATRIX.CHANGE_ID = deleted.CHANGE_ID
    )
    begin
      select @errno  = 30005,
             @errmsg = '%!c_data[C_TRIG_TU_CHANGE_6_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* CHANGE CG_EI INV_EFFECT ON PARENT UPDATE RESTRICT */
  if
    /* %ParentPK(" or",update) */
    update(CHANGE_ID)
  begin
    if exists (
      select * from deleted,<<TAB_QUAL>>.INV_EFFECT
      where
        /*  %JoinFKPK(INV_EFFECT,deleted," = "," and") */
        <<TAB_QUAL>>.INV_EFFECT.CHANGE_ID = deleted.CHANGE_ID
    )
    begin
      select @errno  = 30005,
             @errmsg = '%!c_data[C_TRIG_TU_CHANGE_7_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* CHANGE CG_AP ASSOCIATED_PROBLEM ON PARENT UPDATE RESTRICT */
  if
    /* %ParentPK(" or",update) */
    update(CHANGE_ID)
  begin
    if exists (
      select * from deleted,<<TAB_QUAL>>.ASSOCIATED_PROBLEM
      where
        /*  %JoinFKPK(ASSOCIATED_PROBLEM,deleted," = "," and") */
        <<TAB_QUAL>>.ASSOCIATED_PROBLEM.CHANGE_ID = deleted.CHANGE_ID
    )
    begin
      select @errno  = 30005,
             @errmsg = '%!c_data[C_TRIG_TU_CHANGE_8_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* CHANGE CG_CH CHANGE_HISTORY ON PARENT UPDATE RESTRICT */
  if
    /* %ParentPK(" or",update) */
    update(CHANGE_ID)
  begin
    if exists (
      select * from deleted,<<TAB_QUAL>>.CHANGE_HISTORY
      where
        /*  %JoinFKPK(CHANGE_HISTORY,deleted," = "," and") */
        <<TAB_QUAL>>.CHANGE_HISTORY.CHANGE_ID = deleted.CHANGE_ID
    )
    begin
      select @errno  = 30005,
             @errmsg = '%!c_data[C_TRIG_TU_CHANGE_9_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* CHANGE CG_IS IMPLEMENT_SCHEDULE ON PARENT UPDATE RESTRICT */
  if
    /* %ParentPK(" or",update) */
    update(CHANGE_ID)
  begin
    if exists (
      select * from deleted,<<TAB_QUAL>>.IMPLEMENT_SCHEDULE
      where
        /*  %JoinFKPK(IMPLEMENT_SCHEDULE,deleted," = "," and") */
        <<TAB_QUAL>>.IMPLEMENT_SCHEDULE.CHANGE_ID = deleted.CHANGE_ID
    )
    begin
      select @errno  = 30005,
             @errmsg = '%!c_data[C_TRIG_TU_CHANGE_10_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* CHANGE CG_IM IMPACT ON PARENT UPDATE RESTRICT */
  if
    /* %ParentPK(" or",update) */
    update(CHANGE_ID)
  begin
    if exists (
      select * from deleted,<<TAB_QUAL>>.IMPACT
      where
        /*  %JoinFKPK(IMPACT,deleted," = "," and") */
        <<TAB_QUAL>>.IMPACT.CHANGE_ID = deleted.CHANGE_ID
    )
    begin
      select @errno  = 30005,
             @errmsg = '%!c_data[C_TRIG_TU_CHANGE_11_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* LOCATION LO_CG CHANGE ON CHILD UPDATE RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(LOCATION_ID)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.LOCATION
        where
          /* %JoinFKPK(inserted,LOCATION) */
          inserted.LOCATION_ID = <<TAB_QUAL>>.LOCATION.LOCATION_ID
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.LOCATION_ID is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30007,
             @errmsg = '%!c_data[C_TRIG_TU_CHANGE_12_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* PEOPLE PO_CG_AS CHANGE ON CHILD UPDATE RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(ASSIGNED_TO)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.PEOPLE
        where
          /* %JoinFKPK(inserted,PEOPLE) */
          inserted.ASSIGNED_TO = <<TAB_QUAL>>.PEOPLE.PEOPLE_ID
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.ASSIGNED_TO is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30007,
             @errmsg = '%!c_data[C_TRIG_TU_CHANGE_13_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* PEOPLE PO_CG_RQ CHANGE ON CHILD UPDATE RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(REQUESTER_ID)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.PEOPLE
        where
          /* %JoinFKPK(inserted,PEOPLE) */
          inserted.REQUESTER_ID = <<TAB_QUAL>>.PEOPLE.PEOPLE_ID
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.REQUESTER_ID is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30007,
             @errmsg = '%!c_data[C_TRIG_TU_CHANGE_14_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* ORGANIZATION OR_CG_AR CHANGE ON CHILD UPDATE RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(RESPONSIBLE_AREA)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.ORGANIZATION
        where
          /* %JoinFKPK(inserted,ORGANIZATION) */
          inserted.RESPONSIBLE_AREA = <<TAB_QUAL>>.ORGANIZATION.ORGANIZATION_ID
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.RESPONSIBLE_AREA is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30007,
             @errmsg = '%!c_data[C_TRIG_TU_CHANGE_15_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* ORGANIZATION OR_CG_CC CHANGE ON CHILD UPDATE RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(COST_CENTER)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.ORGANIZATION
        where
          /* %JoinFKPK(inserted,ORGANIZATION) */
          inserted.COST_CENTER = <<TAB_QUAL>>.ORGANIZATION.ORGANIZATION_ID
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.COST_CENTER is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30007,
             @errmsg = '%!c_data[C_TRIG_TU_CHANGE_16_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* CATEGORY CY_CG CHANGE ON CHILD UPDATE RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(CATEGORY)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.CATEGORY
        where
          /* %JoinFKPK(inserted,CATEGORY) */
          inserted.CATEGORY = <<TAB_QUAL>>.CATEGORY.CATEGORY
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30007,
             @errmsg = '%!c_data[C_TRIG_TU_CHANGE_17_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* RISK_CODES RC_CG CHANGE ON CHILD UPDATE RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(RISK_CODE)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.RISK_CODES
        where
          /* %JoinFKPK(inserted,RISK_CODES) */
          inserted.RISK_CODE = <<TAB_QUAL>>.RISK_CODES.RISK_CODE
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.RISK_CODE is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30007,
             @errmsg = '%!c_data[C_TRIG_TU_CHANGE_18_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* CHANGE_STATUS ST_CG CHANGE ON CHILD UPDATE RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(STATUS_ID)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.CHANGE_STATUS
        where
          /* %JoinFKPK(inserted,CHANGE_STATUS) */
          inserted.STATUS_ID = <<TAB_QUAL>>.CHANGE_STATUS.STATUS_ID
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30007,
             @errmsg = '%!c_data[C_TRIG_TU_CHANGE_19_DB]'
      goto error
    end
  end


  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  return
error:
    raiserror @errno @errmsg
    rollback transaction
end
go
               
#REM Enforced by tI_CHANGE_MODEL, tU_CHANGE_MODEL 
#REM ALTER TABLE <<TAB_QUAL>>.CHANGE_MODEL
#REM ADD  (  CONSTRAINT OR_MO_AR FOREIGN KEY  (RESPONSIBLE_AREA)
#REM                REFERENCES <<TAB_QUAL>>.ORGANIZATION ) ;
               
#REM Enforced by tI_CHANGE_MODEL, tU_CHANGE_MODEL 
#REM ALTER TABLE <<TAB_QUAL>>.CHANGE_MODEL
#REM ADD  (  CONSTRAINT OR_MO_CC FOREIGN KEY  (COST_CENTER)
#REM                REFERENCES <<TAB_QUAL>>.ORGANIZATION ) ;
               
#REM ******************************************************
#REM       
#REM    tI_CHANGE_MODEL
#REM    
#REM ******************************************************
               
create trigger tI_CHANGE_MODEL on <<TAB_QUAL>>.CHANGE_MODEL for INSERT as
/* ERwin Builtin Tue Jun 17 09:00:39 1997 */
/* INSERT trigger on <<TAB_QUAL>>.CHANGE_MODEL */
begin
  declare  @numrows int,
           @nullcnt int,
           @validcnt int,
           @errno   int,
           @errmsg  varchar(255)

  select @numrows = @@rowcount
  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* ORGANIZATION OR_MO_AR CHANGE_MODEL ON CHILD INSERT RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(RESPONSIBLE_AREA)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.ORGANIZATION
        where
          /* %JoinFKPK(inserted,ORGANIZATION) */
          inserted.RESPONSIBLE_AREA = <<TAB_QUAL>>.ORGANIZATION.ORGANIZATION_ID
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.RESPONSIBLE_AREA is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30002,
             @errmsg = '%!c_data[C_TRIG_TI_CHANGE_MODEL_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:38 1997 */
  /* ORGANIZATION OR_MO_CC CHANGE_MODEL ON CHILD INSERT RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(COST_CENTER)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.ORGANIZATION
        where
          /* %JoinFKPK(inserted,ORGANIZATION) */
          inserted.COST_CENTER = <<TAB_QUAL>>.ORGANIZATION.ORGANIZATION_ID
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.COST_CENTER is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30002,
             @errmsg = '%!c_data[C_TRIG_TI_CHANGE_MODEL_2_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:39 1997 */
  /* PEOPLE PO_MO_CR CHANGE_MODEL ON CHILD INSERT RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(CREATOR)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.PEOPLE
        where
          /* %JoinFKPK(inserted,PEOPLE) */
          inserted.CREATOR = <<TAB_QUAL>>.PEOPLE.PEOPLE_ID
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.CREATOR is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30002,
             @errmsg = '%!c_data[C_TRIG_TI_CHANGE_MODEL_3_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:39 1997 */
  /* PEOPLE PO_MO_AS CHANGE_MODEL ON CHILD INSERT RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(ASSIGNED_TO)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.PEOPLE
        where
          /* %JoinFKPK(inserted,PEOPLE) */
          inserted.ASSIGNED_TO = <<TAB_QUAL>>.PEOPLE.PEOPLE_ID
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.ASSIGNED_TO is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30002,
             @errmsg = '%!c_data[C_TRIG_TI_CHANGE_MODEL_4_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:39 1997 */
  /* CATEGORY CY_MO CHANGE_MODEL ON CHILD INSERT RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(CATEGORY)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.CATEGORY
        where
          /* %JoinFKPK(inserted,CATEGORY) */
          inserted.CATEGORY = <<TAB_QUAL>>.CATEGORY.CATEGORY
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.CATEGORY is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30002,
             @errmsg = '%!c_data[C_TRIG_TI_CHANGE_MODEL_5_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:39 1997 */
  /* RISK_CODES RC_MO CHANGE_MODEL ON CHILD INSERT RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(RISK_CODE)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.RISK_CODES
        where
          /* %JoinFKPK(inserted,RISK_CODES) */
          inserted.RISK_CODE = <<TAB_QUAL>>.RISK_CODES.RISK_CODE
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.RISK_CODE is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30002,
             @errmsg = '%!c_data[C_TRIG_TI_CHANGE_MODEL_6_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:39 1997 */
  /* CHANGE_STATUS ST_MO CHANGE_MODEL ON CHILD INSERT RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(STATUS_ID)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.CHANGE_STATUS
        where
          /* %JoinFKPK(inserted,CHANGE_STATUS) */
          inserted.STATUS_ID = <<TAB_QUAL>>.CHANGE_STATUS.STATUS_ID
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.STATUS_ID is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30002,
             @errmsg = '%!c_data[C_TRIG_TI_CHANGE_MODEL_7_DB]'
      goto error
    end
  end


  /* ERwin Builtin Tue Jun 17 09:00:39 1997 */
  return
error:
    raiserror @errno @errmsg
    rollback transaction
end
go

#REM ******************************************************
#REM       
#REM    tU_CHANGE_MODEL
#REM    
#REM ******************************************************               

create trigger tU_CHANGE_MODEL on <<TAB_QUAL>>.CHANGE_MODEL for UPDATE as
/* ERwin Builtin Tue Jun 17 09:00:39 1997 */
/* UPDATE trigger on <<TAB_QUAL>>.CHANGE_MODEL */
begin
  declare  @numrows int,
           @nullcnt int,
           @validcnt int,
           @insMODEL_ID int,
           @errno   int,
           @errmsg  varchar(255)

  select @numrows = @@rowcount
  /* ERwin Builtin Tue Jun 17 09:00:39 1997 */
  /* CHANGE_MODEL CH_MA MODEL_ATTACHMENT ON PARENT UPDATE RESTRICT */
  if
    /* %ParentPK(" or",update) */
    update(MODEL_ID)
  begin
    if exists (
      select * from deleted,<<TAB_QUAL>>.MODEL_ATTACHMENT
      where
        /*  %JoinFKPK(MODEL_ATTACHMENT,deleted," = "," and") */
        <<TAB_QUAL>>.MODEL_ATTACHMENT.MODEL_ID = deleted.MODEL_ID
    )
    begin
      select @errno  = 30005,
             @errmsg = '%!c_data[C_TRIG_TU_CHANGE_MODEL_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:39 1997 */
  /* CHANGE_MODEL MO_MA MODEL_APPROVAL ON PARENT UPDATE RESTRICT */
  if
    /* %ParentPK(" or",update) */
    update(MODEL_ID)
  begin
    if exists (
      select * from deleted,<<TAB_QUAL>>.MODEL_APPROVAL
      where
        /*  %JoinFKPK(MODEL_APPROVAL,deleted," = "," and") */
        <<TAB_QUAL>>.MODEL_APPROVAL.MODEL_ID = deleted.MODEL_ID
    )
    begin
      select @errno  = 30005,
             @errmsg = '%!c_data[C_TRIG_TU_CHANGE_MODEL_2_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:39 1997 */
  /* CHANGE_MODEL MO_MT_PA MODEL_TREE ON PARENT UPDATE RESTRICT */
  if
    /* %ParentPK(" or",update) */
    update(MODEL_ID)
  begin
    if exists (
      select * from deleted,<<TAB_QUAL>>.MODEL_TREE
      where
        /*  %JoinFKPK(MODEL_TREE,deleted," = "," and") */
        <<TAB_QUAL>>.MODEL_TREE.PARENT_MODEL_ID = deleted.MODEL_ID
    )
    begin
      select @errno  = 30005,
             @errmsg = '%!c_data[C_TRIG_TU_CHANGE_MODEL_3_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:39 1997 */
  /* CHANGE_MODEL MO_MT_CH MODEL_TREE ON PARENT UPDATE RESTRICT */
  if
    /* %ParentPK(" or",update) */
    update(MODEL_ID)
  begin
    if exists (
      select * from deleted,<<TAB_QUAL>>.MODEL_TREE
      where
        /*  %JoinFKPK(MODEL_TREE,deleted," = "," and") */
        <<TAB_QUAL>>.MODEL_TREE.CHILD_MODEL_ID = deleted.MODEL_ID
    )
    begin
      select @errno  = 30005,
             @errmsg = '%!c_data[C_TRIG_TU_CHANGE_MODEL_4_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:39 1997 */
  /* CHANGE_MODEL MO_MI MODEL_IMPACT ON PARENT UPDATE RESTRICT */
  if
    /* %ParentPK(" or",update) */
    update(MODEL_ID)
  begin
    if exists (
      select * from deleted,<<TAB_QUAL>>.MODEL_IMPACT
      where
        /*  %JoinFKPK(MODEL_IMPACT,deleted," = "," and") */
        <<TAB_QUAL>>.MODEL_IMPACT.MODEL_ID = deleted.MODEL_ID
    )
    begin
      select @errno  = 30005,
             @errmsg = '%!c_data[C_TRIG_TU_CHANGE_MODEL_5_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:39 1997 */
  /* CHANGE_MODEL MO_MS MODEL_SCHEDULE ON PARENT UPDATE RESTRICT */
  if
    /* %ParentPK(" or",update) */
    update(MODEL_ID)
  begin
    if exists (
      select * from deleted,<<TAB_QUAL>>.MODEL_SCHEDULE
      where
        /*  %JoinFKPK(MODEL_SCHEDULE,deleted," = "," and") */
        <<TAB_QUAL>>.MODEL_SCHEDULE.MODEL_ID = deleted.MODEL_ID
    )
    begin
      select @errno  = 30005,
             @errmsg = '%!c_data[C_TRIG_TU_CHANGE_MODEL_6_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:39 1997 */
  /* ORGANIZATION OR_MO_AR CHANGE_MODEL ON CHILD UPDATE RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(RESPONSIBLE_AREA)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.ORGANIZATION
        where
          /* %JoinFKPK(inserted,ORGANIZATION) */
          inserted.RESPONSIBLE_AREA = <<TAB_QUAL>>.ORGANIZATION.ORGANIZATION_ID
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.RESPONSIBLE_AREA is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30007,
             @errmsg = '%!c_data[C_TRIG_TU_CHANGE_MODEL_7_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:39 1997 */
  /* ORGANIZATION OR_MO_CC CHANGE_MODEL ON CHILD UPDATE RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(COST_CENTER)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.ORGANIZATION
        where
          /* %JoinFKPK(inserted,ORGANIZATION) */
          inserted.COST_CENTER = <<TAB_QUAL>>.ORGANIZATION.ORGANIZATION_ID
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.COST_CENTER is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30007,
             @errmsg = '%!c_data[C_TRIG_TU_CHANGE_MODEL_8_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:39 1997 */
  /* PEOPLE PO_MO_CR CHANGE_MODEL ON CHILD UPDATE RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(CREATOR)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.PEOPLE
        where
          /* %JoinFKPK(inserted,PEOPLE) */
          inserted.CREATOR = <<TAB_QUAL>>.PEOPLE.PEOPLE_ID
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.CREATOR is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30007,
             @errmsg = '%!c_data[C_TRIG_TU_CHANGE_MODEL_9_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:39 1997 */
  /* PEOPLE PO_MO_AS CHANGE_MODEL ON CHILD UPDATE RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(ASSIGNED_TO)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.PEOPLE
        where
          /* %JoinFKPK(inserted,PEOPLE) */
          inserted.ASSIGNED_TO = <<TAB_QUAL>>.PEOPLE.PEOPLE_ID
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.ASSIGNED_TO is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30007,
             @errmsg = '%!c_data[C_TRIG_TU_CHANGE_MODEL_10_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:39 1997 */
  /* CATEGORY CY_MO CHANGE_MODEL ON CHILD UPDATE RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(CATEGORY)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.CATEGORY
        where
          /* %JoinFKPK(inserted,CATEGORY) */
          inserted.CATEGORY = <<TAB_QUAL>>.CATEGORY.CATEGORY
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.CATEGORY is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30007,
             @errmsg = '%!c_data[C_TRIG_TU_CHANGE_MODEL_11_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:39 1997 */
  /* RISK_CODES RC_MO CHANGE_MODEL ON CHILD UPDATE RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(RISK_CODE)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.RISK_CODES
        where
          /* %JoinFKPK(inserted,RISK_CODES) */
          inserted.RISK_CODE = <<TAB_QUAL>>.RISK_CODES.RISK_CODE
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.RISK_CODE is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30007,
             @errmsg = '%!c_data[C_TRIG_TU_CHANGE_MODEL_12_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:39 1997 */
  /* CHANGE_STATUS ST_MO CHANGE_MODEL ON CHILD UPDATE RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(STATUS_ID)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.CHANGE_STATUS
        where
          /* %JoinFKPK(inserted,CHANGE_STATUS) */
          inserted.STATUS_ID = <<TAB_QUAL>>.CHANGE_STATUS.STATUS_ID
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.STATUS_ID is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30007,
             @errmsg = '%!c_data[C_TRIG_TU_CHANGE_MODEL_13_DB]'
      goto error
    end
  end


  /* ERwin Builtin Tue Jun 17 09:00:39 1997 */
  return
error:
    raiserror @errno @errmsg
    rollback transaction
end
go
               
#REM Not found in mss scripts.
#REM ALTER TABLE <<TAB_QUAL>>.IMPACT_ITEM
#REM ADD  (  CONSTRAINT IM_OR FOREIGN KEY  (ORGANIZATION_ID)
#REM                REFERENCES <<TAB_QUAL>>.ORGANIZATION ) ;
               
#REM Enforced by tI_MODEL_APPROVAL, tU_MODEL_APPROVAL               
#REM ALTER TABLE <<TAB_QUAL>>.MODEL_APPROVAL
#REM ADD  (  CONSTRAINT OR_MA FOREIGN KEY  (ORGANIZATION_ID)
#REM                REFERENCES <<TAB_QUAL>>.ORGANIZATION ) ;
               
#REM ******************************************************
#REM       
#REM    tI_MODEL_APPROVAL
#REM    
#REM ******************************************************               
               
create trigger tI_MODEL_APPROVAL on <<TAB_QUAL>>.MODEL_APPROVAL for INSERT as
/* ERwin Builtin Tue Jun 17 09:00:40 1997 */
/* INSERT trigger on <<TAB_QUAL>>.MODEL_APPROVAL */
begin
  declare  @numrows int,
           @nullcnt int,
           @validcnt int,
           @errno   int,
           @errmsg  varchar(255)

  select @numrows = @@rowcount
  /* ERwin Builtin Tue Jun 17 09:00:40 1997 */
  /* PEOPLE PO_MA MODEL_APPROVAL ON CHILD INSERT RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(PEOPLE_ID)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.PEOPLE
        where
          /* %JoinFKPK(inserted,PEOPLE) */
          inserted.PEOPLE_ID = <<TAB_QUAL>>.PEOPLE.PEOPLE_ID
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.PEOPLE_ID is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30002,
             @errmsg = '%!c_data[C_TRIG_TI_MODEL_APPROVAL_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:40 1997 */
  /* CHANGE_CONTROL_BOA CC_MA MODEL_APPROVAL ON CHILD INSERT RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(CCB_NAME)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.CHANGE_CONTROL_BOA
        where
          /* %JoinFKPK(inserted,CHANGE_CONTROL_BOA) */
          inserted.CCB_NAME = <<TAB_QUAL>>.CHANGE_CONTROL_BOA.CCB_NAME
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.CCB_NAME is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30002,
             @errmsg = '%!c_data[C_TRIG_TI_MODEL_APPROVAL_2_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:40 1997 */
  /* ORGANIZATION OR_MA MODEL_APPROVAL ON CHILD INSERT RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(ORGANIZATION_ID)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.ORGANIZATION
        where
          /* %JoinFKPK(inserted,ORGANIZATION) */
          inserted.ORGANIZATION_ID = <<TAB_QUAL>>.ORGANIZATION.ORGANIZATION_ID
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.ORGANIZATION_ID is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30002,
             @errmsg = '%!c_data[C_TRIG_TI_MODEL_APPROVAL_3_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:40 1997 */
  /* CHANGE_MODEL MO_MA MODEL_APPROVAL ON CHILD INSERT RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(MODEL_ID)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.CHANGE_MODEL
        where
          /* %JoinFKPK(inserted,CHANGE_MODEL) */
          inserted.MODEL_ID = <<TAB_QUAL>>.CHANGE_MODEL.MODEL_ID
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30002,
             @errmsg = '%!c_data[C_TRIG_TI_MODEL_APPROVAL_4_DB]'
      goto error
    end
  end


  /* ERwin Builtin Tue Jun 17 09:00:40 1997 */
  return
error:
    raiserror @errno @errmsg
    rollback transaction
end
go

#REM ******************************************************
#REM       
#REM    tU_MODEL_APPROVAL
#REM    
#REM ******************************************************               

create trigger tU_MODEL_APPROVAL on <<TAB_QUAL>>.MODEL_APPROVAL for UPDATE as
/* ERwin Builtin Tue Jun 17 09:00:40 1997 */
/* UPDATE trigger on <<TAB_QUAL>>.MODEL_APPROVAL */
begin
  declare  @numrows int,
           @nullcnt int,
           @validcnt int,
           @insAPPROVER_ID int,
           @errno   int,
           @errmsg  varchar(255)

  select @numrows = @@rowcount
  /* ERwin Builtin Tue Jun 17 09:00:40 1997 */
  /* PEOPLE PO_MA MODEL_APPROVAL ON CHILD UPDATE RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(PEOPLE_ID)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.PEOPLE
        where
          /* %JoinFKPK(inserted,PEOPLE) */
          inserted.PEOPLE_ID = <<TAB_QUAL>>.PEOPLE.PEOPLE_ID
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.PEOPLE_ID is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30007,
             @errmsg = '%!c_data[C_TRIG_TU_MODEL_APPROVAL_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:40 1997 */
  /* CHANGE_CONTROL_BOA CC_MA MODEL_APPROVAL ON CHILD UPDATE RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(CCB_NAME)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.CHANGE_CONTROL_BOA
        where
          /* %JoinFKPK(inserted,CHANGE_CONTROL_BOA) */
          inserted.CCB_NAME = <<TAB_QUAL>>.CHANGE_CONTROL_BOA.CCB_NAME
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.CCB_NAME is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30007,
             @errmsg = '%!c_data[C_TRIG_TU_MODEL_APPROVAL_2_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:40 1997 */
  /* ORGANIZATION OR_MA MODEL_APPROVAL ON CHILD UPDATE RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(ORGANIZATION_ID)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.ORGANIZATION
        where
          /* %JoinFKPK(inserted,ORGANIZATION) */
          inserted.ORGANIZATION_ID = <<TAB_QUAL>>.ORGANIZATION.ORGANIZATION_ID
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    select @nullcnt = count(*) from inserted where
      inserted.ORGANIZATION_ID is null
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30007,
             @errmsg = '%!c_data[C_TRIG_TU_MODEL_APPROVAL_3_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:40 1997 */
  /* CHANGE_MODEL MO_MA MODEL_APPROVAL ON CHILD UPDATE RESTRICT */
  if
    /* %ChildFK(" or",update) */
    update(MODEL_ID)
  begin
    select @nullcnt = 0
    select @validcnt = count(*)
      from inserted,<<TAB_QUAL>>.CHANGE_MODEL
        where
          /* %JoinFKPK(inserted,CHANGE_MODEL) */
          inserted.MODEL_ID = <<TAB_QUAL>>.CHANGE_MODEL.MODEL_ID
    /* %NotnullFK(inserted," is null","select @nullcnt = count(*) from inserted where"," and") */
    
    if @validcnt + @nullcnt != @numrows
    begin
      select @errno  = 30007,
             @errmsg = '%!c_data[C_TRIG_TU_MODEL_APPROVAL_4_DB]'
      goto error
    end
  end


  /* ERwin Builtin Tue Jun 17 09:00:40 1997 */
  return
error:
    raiserror @errno @errmsg
    rollback transaction
end
go

#REM (* ****************************************************************************************   
#REM    6.0-TSD-0014 Defect EQ21392
#REM     Migration of IS_INVENTORY/Organization fails
#REM    MSS 18May00
#REM    **************************************************************************************** *)

create trigger tU_ORGANIZATION on <<TAB_QUAL>>.ORGANIZATION for UPDATE as
/* UPDATE trigger on <<TAB_QUAL>>.ORGANIZATION */
begin
  declare  @numrows int,
           @nullcnt int,
           @validcnt int,
           @insORGANIZATION_ID char(15),
           @errno   int,
           @errmsg  varchar(255)

  select @numrows = @@rowcount
  /* I_52 ORGANIZATION is owned by IS_INVENTORY on PARENT UPDATE RESTRICT */
  if
    /* %ParentPK(" or",update) */
    update(ORGANIZATION_ID)
  begin
    if exists (
      select * from deleted, <<TAB_QUAL>>.IS_INVENTORY
      where
        /*  %JoinFKPK(IS_INVENTORY,deleted," = "," and") */
        <<TAB_QUAL>>.IS_INVENTORY.ORGANIZATION_ID = deleted.ORGANIZATION_ID
    )
    begin
      select @errno  = 60005,
             @errmsg = '%!b_data[B_TRIG_TU_ORGANIZATION_DB]'
      goto error
    end
  end
  /* I_30 ORGANIZATION has members ORG_MEMBERSHIP on PARENT UPDATE RESTRICT */
  if
    /* %ParentPK(" or",update) */
    update(ORGANIZATION_ID)
  begin
    if exists (
      select * from deleted, <<TAB_QUAL>>.ORG_MEMBERSHIP
      where
        /*  %JoinFKPK(ORG_MEMBERSHIP,deleted," = "," and") */
        <<TAB_QUAL>>.ORG_MEMBERSHIP.ORGANIZATION_ID = deleted.ORGANIZATION_ID
    )
    begin
      select @errno  = 60005,
             @errmsg = '%!b_data[B_TRIG_TU_ORGANIZATION_2_DB]'
      goto error
    end
  end
  /* W_3 ORGANIZATION has rights in EWEB_ORG_RIGHTS on PARENT UPDATE RESTRICT */
  if
    update(ORGANIZATION_ID)
  begin
    if exists (
      select * from deleted, <<TAB_QUAL>>.EWEB_ORG_RIGHTS
      where
        <<TAB_QUAL>>.EWEB_ORG_RIGHTS.ORGANIZATION_ID = deleted.ORGANIZATION_ID
    )
    begin
      select @errno  = 60005,
             @errmsg = '%!b_data[B_TRIG_TU_ORGANIZATION_3_DB]'
      goto error
    end
  end  
  /* R_144 ORGANIZATION has supporters in SUPPORT_FOR on PARENT UPDATE RESTRICT */
  if
    update(ORGANIZATION_ID)
  begin
    if exists (
      select * from deleted, <<TAB_QUAL>>.SUPPORT_FOR
      where
        <<TAB_QUAL>>.SUPPORT_FOR.ORGANIZATION_ID = deleted.ORGANIZATION_ID
    )
    begin
      select @errno  = 60005,
             @errmsg = '%!b_data[B_TRIG_TU_ORGANIZATION_4_DB]'
      goto error
    end
  end  
  /* R_145 ORGANIZATION has settings in ORG_SETTING on PARENT UPDATE RESTRICT */
  if
    update(ORGANIZATION_ID)
  begin
    if exists (
      select * from deleted, <<TAB_QUAL>>.ORG_SETTING
      where
        <<TAB_QUAL>>.ORG_SETTING.ORGANIZATION_ID = deleted.ORGANIZATION_ID
    )
    begin
      select @errno  = 60005,
             @errmsg = '%!b_data[B_TRIG_TU_ORGANIZATION_5_DB]'
      goto error
    end
  end
  
  return
error:
    raiserror @errno @errmsg
    rollback transaction
end
go

create trigger tU_IS_INVENTORY on <<TAB_QUAL>>.IS_INVENTORY for UPDATE as
/* UPDATE trigger on <<TAB_QUAL>>.IS_INVENTORY */
begin
  declare  @numrows int,
           @nullcnt int,
           @validcnt int,
           @insIS_INVENTORY_ID int,
           @errno   int,
           @errmsg  varchar(255)

  select @numrows = @@rowcount
  /* I_15 IS_INVENTORY may have MAINTENANCE_FEE on PARENT UPDATE RESTRICT */
  if
    /* %ParentPK(" or",update) */
    update(IS_INVENTORY_ID)
  begin
    if exists (
      select * from deleted, <<TAB_QUAL>>.MAINTENANCE_FEE
      where
        /*  %JoinFKPK(MAINTENANCE_FEE,deleted," = "," and") */
        <<TAB_QUAL>>.MAINTENANCE_FEE.IS_INVENTORY_ID = deleted.IS_INVENTORY_ID
    )
    begin
      select @errno  = 60005,
             @errmsg = '%!b_data[B_TRIG_TU_IS_INVENTORY_DB]'
      goto error
    end
  end
  /* I_21 IS_INVENTORY actions may be based on contracts INV_CONTRACT on PARENT UPDATE RESTRICT */
  if
    /* %ParentPK(" or",update) */
    update(IS_INVENTORY_ID)
  begin
    if exists (
      select * from deleted, <<TAB_QUAL>>.INV_CONTRACT
      where
        /*  %JoinFKPK(INV_CONTRACT,deleted," = "," and") */
        <<TAB_QUAL>>.INV_CONTRACT.IS_INVENTORY_ID = deleted.IS_INVENTORY_ID
    )
    begin
      select @errno  = 60005,
             @errmsg = '%!b_data[B_TRIG_TU_IS_INVENTORY_2_DB]'
      goto error
    end
  end
  /* I_9 IS_INVENTORY is a PM_OBJECT on PARENT UPDATE RESTRICT */
  if
    /* %ParentPK(" or",update) */
    update(IS_INVENTORY_ID)
  begin
    if exists (
      select * from deleted, <<TAB_QUAL>>.PM_OBJECT
      where
        /*  %JoinFKPK(PM_OBJECT,deleted," = "," and") */
        <<TAB_QUAL>>.PM_OBJECT.IS_INVENTORY_ID = deleted.IS_INVENTORY_ID
    )
    begin
      select @errno  = 60005,
             @errmsg = '%!b_data[B_TRIG_TU_IS_INVENTORY_3_DB]'
      goto error
    end
  end
  /* I_55 IS_INVENTORY may have value VALUATION on PARENT UPDATE RESTRICT */
  if
    /* %ParentPK(" or",update) */
    update(IS_INVENTORY_ID)
  begin
    if exists (
      select * from deleted, <<TAB_QUAL>>.VALUATION
      where
        /*  %JoinFKPK(VALUATION,deleted," = "," and") */
        <<TAB_QUAL>>.VALUATION.IS_INVENTORY_ID = deleted.IS_INVENTORY_ID
    )
    begin
      select @errno  = 60005,
             @errmsg = '%!b_data[B_TRIG_TU_IS_INVENTORY_4_DB]'
      goto error
    end
  end
  /* I_11 IS_INVENTORY may have events INVENTORY_HISTORY on PARENT UPDATE RESTRICT */
  if
    /* %ParentPK(" or",update) */
    update(IS_INVENTORY_ID)
  begin
    if exists (
      select * from deleted, <<TAB_QUAL>>.INVENTORY_HISTORY
      where
        /*  %JoinFKPK(INVENTORY_HISTORY,deleted," = "," and") */
        <<TAB_QUAL>>.INVENTORY_HISTORY.IS_INVENTORY_ID = deleted.IS_INVENTORY_ID
    )
    begin
      select @errno  = 60005,
             @errmsg = '%!b_data[B_TRIG_TU_IS_INVENTORY_5_DB]'
      goto error
    end
  end
  /* ERwin Builtin Tue Jun 17 09:00:40 1997 */
  /* IS_INVENTORY IN_EO INV_EFFECT_ON ON PARENT UPDATE RESTRICT */
  if
    /* %ParentPK(" or",update) */
    update(IS_INVENTORY_ID)
  begin
    if exists (
      select * from deleted,<<TAB_QUAL>>.INV_EFFECT_ON
      where
        /*  %JoinFKPK(INV_EFFECT_ON,deleted," = "," and") */
        <<TAB_QUAL>>.INV_EFFECT_ON.IS_INVENTORY_ID = deleted.IS_INVENTORY_ID
    )
    begin
      select @errno  = 30005,
             @errmsg = '%!b_data[B_TRIG_TU_IS_INVENTORY_6_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:40 1997 */
  /* IS_INVENTORY IN_IV IMPACT_INVENTORY ON PARENT UPDATE RESTRICT */
  if
    /* %ParentPK(" or",update) */
    update(IS_INVENTORY_ID)
  begin
    if exists (
      select * from deleted,<<TAB_QUAL>>.IMPACT_INVENTORY
      where
        /*  %JoinFKPK(IMPACT_INVENTORY,deleted," = "," and") */
        <<TAB_QUAL>>.IMPACT_INVENTORY.IS_INVENTORY_ID = deleted.IS_INVENTORY_ID
    )
    begin
      select @errno  = 30005,
             @errmsg = '%!b_data[B_TRIG_TU_IS_INVENTORY_7_DB]'
      goto error
    end
  end

  /* ERwin Builtin Tue Jun 17 09:00:40 1997 */
  /* IS_INVENTORY IN_SI SCHED_INVENTORY ON PARENT UPDATE RESTRICT */
  if
    /* %ParentPK(" or",update) */
    update(IS_INVENTORY_ID)
  begin
    if exists (
      select * from deleted,<<TAB_QUAL>>.SCHED_INVENTORY
      where
        /*  %JoinFKPK(SCHED_INVENTORY,deleted," = "," and") */
        <<TAB_QUAL>>.SCHED_INVENTORY.IS_INVENTORY_ID = deleted.IS_INVENTORY_ID
    )
    begin
      select @errno  = 30005,
             @errmsg = '%!b_data[B_TRIG_TU_IS_INVENTORY_8_DB]'
      goto error
    end
  end

  return
error:
    raiserror @errno @errmsg
    rollback transaction
end
go

#REM (* ****************************************************************************************   
#REM    END 6.0-TSD-0014 Defect EQ21392
#REM    **************************************************************************************** *)
